<?php
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// *READ ME FIRST* 
// 
// Prestashop - Xpdy Standalone Connector v1.0 -  Copyrights : Expedy
// 
// SETUP :
//
// Prequisites : first, create a dedicated employee (email/password) in your prestashop control panel
// with access to your orders data, and communicate these credentials to your Expedy contact or via your Expedy console
// then upload this file via ftp in your prestashop directory. You should now be able to see your orders via your Expedy console 
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

$host = $_SERVER['HTTP_HOST'];
$bhost = (isset($_SERVER["HTTPS"]) ? 'https' : 'http');

require '../../config/config.inc.php';

$checked = 0;
$tn = time();
$user = $_REQUEST['user']; 
$psw = $_REQUEST['psw'];
$drequest = $_REQUEST['drequest'];
$doffset = $_REQUEST['doffset'];		
$dsort = $_REQUEST['dsort'];		
 
function human_date($ddate) {
  $p = '/^(\d{4})-(\d{2})-(\d{2})\s+(\d{2}):(\d{2}):(\d{2})$/i';
  if (preg_match($p, $ddate, $x)) {
    $unixd = mktime($x[4], $x[5], $x[6], $x[2], $x[3], $x[1]);
    return gmdate('Y-m-d\TH:i:s', $unixd);
  }
  return $ddate;
}

//$ptz = new DateTimeZone(Configuration::get('PS_TIMEZONE'));



                 $id_order = $_REQUEST['id'];
                 $id_order = 97;
                 $id_order = 11694;
//  $id_order = 55;
               //  $order_infos['id_cart'] = "";
                 
                 
                 

        //////////
        // Rpr les informations de la commande
        
        // requ sur la base de donn褳 (utilisation de la classe Db)
        $sql = "SELECT o.`id_order`
                      ,o.`id_cart`
                      ,o.`id_carrier`
                      ,o.`reference`
                      ,o.`total_paid_tax_excl`
                      ,o.`total_paid_tax_incl`
                      ,o.`date_add`
                      ,o.`payment`
                      ,cl.`delay`
                      ,ad.`company`
                      ,ad.`lastname`
                      ,ad.`firstname`
                      ,ad.`address1`
                      ,ad.`address2`
                      ,ad.`postcode`
                      ,ad.`city`
                      ,ad.`other`
                      ,ad.`phone`
                      ,ad.`phone_mobile`
                      ,od.`id_order_detail`
                      ,od.`product_name` AS 'product_cart_name'
                      ,od.`product_quantity`
                      ,od.`product_id`
                      ,od.`product_reference`
                      ,od.`total_price_tax_excl` AS 'product_total'
                      ,od.`total_price_tax_incl` AS 'product_total_wt'
                      ,prd.`ean13`
                      ,pl.`name` AS 'product_name'
                      ,tl.`name` AS 'product_tax_name'
                      ,atl.`name` AS 'attribut_name'
                      ,m.`message`
                FROM `"._DB_PREFIX_."orders` AS o
                LEFT JOIN `"._DB_PREFIX_."carrier_lang` AS cl ON  cl.id_shop = o.id_shop
                                                              AND cl.id_lang = o.id_lang
                                                              AND cl.id_carrier = o.id_carrier
                LEFT JOIN `"._DB_PREFIX_."address` AS ad ON ad.id_address = o.id_address_delivery
                LEFT JOIN `"._DB_PREFIX_."order_detail` AS od ON od.id_order = o.id_order
                LEFT JOIN `"._DB_PREFIX_."product` AS prd ON prd.id_product = od.product_id
                LEFT JOIN `"._DB_PREFIX_."product_lang` AS pl ON  pl.id_product = od.product_id
                                                              AND pl.id_shop = o.id_shop
                                                              AND pl.id_lang = o.id_lang
                LEFT JOIN `"._DB_PREFIX_."order_detail_tax` AS t_odt ON t_odt.id_order_detail = od.id_order_detail
                LEFT JOIN `"._DB_PREFIX_."tax_lang` AS tl ON  tl.id_tax = t_odt.id_tax
                                                          AND tl.id_lang = o.id_lang
                LEFT JOIN `"._DB_PREFIX_."product_attribute_combination` AS pac
                                                            ON pac.id_product_attribute = od.product_attribute_id
                LEFT JOIN `"._DB_PREFIX_."attribute_lang` AS atl ON  atl.id_attribute = pac.id_attribute
                                                                 AND atl.id_lang = o.id_lang
                LEFT JOIN  `"._DB_PREFIX_."message` AS m  ON m.id_order = o.id_order
                                                         AND m.id_cart = o.id_cart
                                                         AND m.id_customer = o.id_customer
                                                         AND private = 0
                WHERE o.id_order = ".$id_order."
                ORDER BY od.`id_order_detail` ASC";
        $dbResult = Db::getInstance()->executeS($sql);
        
        
        //////////
        //  Placer les informations dans un tableau
        
        $order_infos  = array();    // tableau contenant les informations de la commande
        $product_list = array();    // tableau contenant les produits de la commande
        $product      = null;
        $attributs    = "";
        
        // parcours des lignes du rltat de la requ
        foreach ($dbResult as $row) {
            // Si ce n'est pas encore fait, rpr les informations de la commande
            if (!isset($order_infos['id_order'])) {
                $order_infos['id_order']            = $row['id_order'];
                $order_infos['id_cart']             = $row['id_cart'];
                $order_infos['id_carrier']             = $row['id_carrier'];
                $order_infos['reference']           = $row['reference'];
                $order_infos['total_paid_tax_incl'] = $row['total_paid_tax_incl'];
                $order_infos['total_paid_tax_excl'] = $row['total_paid_tax_excl'];
                $order_infos['date_add']            = $row['date_add'];
                $order_infos['carrier']             = $row['delay'];
                $order_infos['payment']             = $row['payment'];
                $order_infos['message']             = $row['message'];
                $order_infos['id_store']            = "";
                $order_infos['delivery_address']    = array(
                                                        'company'   => $row['company'],
                                                        'lastname'  => $row['lastname'],
                                                        'firstname' => $row['firstname'],
                                                        'address1'  => $row['address1'],
                                                        'address2'  => $row['address2'],
                                                        'postcode'  => $row['postcode'],
                                                        'city'      => $row['city'],
                                                        'other'     => $row['other'],
                                                        'phone'     => $row['phone'],
                                                        'phone_mobile'     => $row['phone_mobile']
                                                      );
                $order_infos['product_list']        = null;
            }
            
            // Si l'identifiant du produit de la ligne parcourue est diffnt du produit actuel,
            // Alors placer le produit actuel dans la liste et il n'y a plus de produit actuel.
            if (null != $product
            &&  $product['id_order_detail'] != $row['id_order_detail']) {
                $product['attributes_small'] = $attributs;
                array_push($product_list, $product);
                
                $product = null;
                $attributs = "";
            }
            
            // S'il n'y a pas de produit actuel, en renseigner un nouveau.
            if (null == $product) {
                $product = array(
                            'id_order_detail'  => $row['id_order_detail'],
                            'product_id'       => $row['product_id'],
                            'reference'        => $row['product_reference'],
                            'ean13'            => $row['ean13'],
                            'name'             => $row['product_name'],
                            'cart_name'        => $row['product_cart_name'],
                            'quantity'         => $row['product_quantity'],
                            'total'            => $row['product_total'],
                            'total_wt'         => $row['product_total_wt'],
                            'tax_name'         => $row['product_tax_name'],
                            'attributes_small' => ""
                            );
            }
            
            if ("" != $attributs) {
                $attributs .= ", ";
            }
            $attributs .= $row['attribut_name'];
        }
        // FIN parcours des lignes du rltat de la requ
        
        // placer le produit actuel dans la liste
        if (null != $product) {
            $product['attributes_small'] = $attributs;
            array_push($product_list, $product);
        }
        
        // placer la liste des produits dans la commande
        $order_infos['product_list'] = $product_list;
        

        // Si le module fspickupatstorecarrier est install       
         if (Module::isInstalled(Tools::strtolower('fspickupatstorecarrier'))) {
            // rpr les informations de ce module pour cette commande
            $sql = "SELECT `id_fspickupatstorecarrier`
                          ,`id_order`
                          ,`id_store`
                          ,`date_pickup`
                          ,`date_add`
                          ,`date_upd`
                    FROM `fspickupatstorecarrier`
                    WHERE `id_order` = " . $id_order;
            
            $dbResult = Db::getInstance()->executeS($sql);
            
            if(isset($dbResult[0])) {
                // ajouter la date de retrait en magasin aux informations de la commande
                $order_infos['pickupatstore_date_pickup'] = $dbResult[0]['date_pickup'];
            }
        }
        // End Si le module fspickupatstorecarrier est install
       // Si le module preferreddeliverytime est install
        if (Module::isInstalled(Tools::strtolower('preferreddeliverytime'))) {

           $id_cart_trg = $order_infos['id_cart'];
           
            // rpr les informations de ce module pour cette commande

            $sql_preferred = "SELECT `preferred_date`
                          ,`preferred_time`
                    FROM `"._DB_PREFIX_."preferred_delivery_time`
                    WHERE `id_cart` = " . $id_cart_trg;

            

            $dbResult_preferedtime = Db::getInstance()->executeS($sql_preferred);

            

            if(isset($dbResult_preferedtime[0])) {

                // ajouter la date de retrait en magasin aux informations de la commande

                $order_infos['preferred_date'] = $dbResult_preferedtime[0]['preferred_date'];
                $order_infos['preferred_time'] = $dbResult_preferedtime[0]['preferred_time'];
            }

        }
         
       // End Si le module preferreddeliverytime est install

        // Si le module prestatillhomedelivery est install        
        if (Module::isInstalled(Tools::strtolower('prestatillhomedelivery'))) {
            // rpr les informations de ce module pour cette commande
            $sql = "SELECT `hour`
                          ,`day`
                    FROM `"._DB_PREFIX_."prestatill_homedelivery_creneau`
                    WHERE `id_cart` = " . $order_infos['id_cart'];
            
            $prestatillhomedelivery_dbResult = Db::getInstance()->executeS($sql);
            
            
            if(isset($prestatillhomedelivery_dbResult[0])) {
                // ajouter la date de retrait en magasin aux informations de la commande
                $order_infos['prestatillhomedelivery_date_pickup'] = date("d-m-Y", strtotime($prestatillhomedelivery_dbResult[0]['day']))." - ".$prestatillhomedelivery_dbResult[0]['hour'];
                $prestatillhomedelivery_active = 1;
               // get carrier "name"  
                $sql_next = "SELECT `name`
                       FROM `"._DB_PREFIX_."carrier`
                       WHERE `id_carrier` = " . $order_infos['id_carrier']; 
                $prestatillhomedelivery_dbResult_next = Db::getInstance()->executeS($sql_next);
                if(isset($prestatillhomedelivery_dbResult_next[0])) {
                $order_infos['prestatillhomedelivery_carrier_name'] = $prestatillhomedelivery_dbResult_next[0]['name'];
                }
                 // end get carrier "name"  


            }
        }
        // End Si le module prestatillhomedelivery est install

        // Si le module prestatilldrive est install 
        if (Module::isInstalled(Tools::strtolower('prestatilldrive'))) {
            // rpr les informations de ce module pour cette commande
            $sql = "SELECT `hour`
                          ,`day`
                          ,`id_store`
                    FROM `"._DB_PREFIX_."prestatill_drive_creneau`
                    WHERE `id_order` = " . $id_order;
            
            $prestatilldrive_dbResultx = Db::getInstance()->executeS($sql);
            
            if(isset($prestatilldrive_dbResultx[0])) {
                // ajouter la date de retrait en magasin aux informations de la commande
                $order_infos['prestatilldrive_date_pickup'] = date("d-m-Y", strtotime($prestatilldrive_dbResultx[0]['day']))." - ".$prestatilldrive_dbResultx[0]['hour'];
            
               // get carrier "name"  
                $sql_next = "SELECT `name`
                                    ,`address1`
                       FROM `"._DB_PREFIX_."store_lang`
                       WHERE `id_store` = " . $prestatilldrive_dbResultx[0]['id_store']; 
                $prestatilldrive_dbResult_next = Db::getInstance()->executeS($sql_next);
                if(isset($prestatilldrive_dbResult_next[0])) {
                $order_infos['prestatilldrive_carrier_name'] = $prestatilldrive_dbResult_next[0]['name']." ".$prestatilldrive_dbResult_next[0]['address1'];

                $order_infos['id_store'] = $prestatilldrive_dbResultx[0]['id_store'];
                
                }
                 // end get carrier "name"  
                 
                
            }
        }
        
     
        // End Si le module prestatilldrive est install        
        // Si le module prestadrive est install       
       if (Module::isInstalled(Tools::strtolower('prestadrive'))) {
            // rpr les informations de ce module pour cette commande
            $sql = "SELECT `complet_drive_time`
                          ,`hour_drive_time`
                    FROM `"._DB_PREFIX_."prestadrive_order`
                    WHERE `id_prestashop_cart` = " . $order_infos['id_cart'];
            
            $dbResultx = Db::getInstance()->executeS($sql);
            
            if(isset($dbResultx[0])) {
                // ajouter la date de retrait en magasin aux informations de la commande
                $order_infos['prestadrive_date_pickup'] = date("d-m-Y", strtotime($dbResultx[0]['complet_drive_time']))."".$dbResultx[0]['hour_drive_time'];
            
                // get carrier "name"  
                $sql_next = "SELECT `name`
                       FROM `"._DB_PREFIX_."carrier`
                       WHERE `id_carrier` = " . $order_infos['id_carrier']; 
                $dbResult_next = Db::getInstance()->executeS($sql_next);
                if(isset($dbResult_next[0])) {
                $order_infos['prestadrive_carrier_name'] = $dbResult_next[0]['name'];
                }
                 // end get carrier "name"  
                 
                
            }
        }
        // End Si le module prestadrive est install        
        // retourner le tableau contenant les informations de la commande
      //  return $order_infos;
    
                // find configator data in dbprefix_configurator_cart_detail
               
           
            // rpr les informations de ce module pour cette commande


if (isset($order_infos['product_list'])) {
	
	

	
	
            foreach ($order_infos['product_list'] as $value) {
                // quantinom | rrence) {prix}
                //   {attributs}
    
             // start get configurator product details
                            
                 $product_id_targ =  $value['product_id'];
                 $ean13 =  $value['ean13'];

                 $id_order_detail_targ = $value['id_order_detail'];
                 $order_id_targ = $order_infos['id_order'];
 
 
               // start get configurator product details  

$prod_data_echo = "";

     if (Module::isInstalled(Tools::strtolower('configurator'))) {

           
            // rpr les informations de ce module pour cette commande

            $sql_prod_conf_detl_trg = "SELECT `detail`
                    FROM `"._DB_PREFIX_."configurator_cart_detail`
                    WHERE `id_order` = " . $order_id_targ . " AND `id_product` = " . $product_id_targ . " AND `id_order_detail` = " . $id_order_detail_targ;

            

            $dbResult_prod_conf_detl_trg = Db::getInstance()->executeS($sql_prod_conf_detl_trg);

            

            if(isset($dbResult_prod_conf_detl_trg[0])) {

                // ajouter la date de retrait en magasin aux informations de la commande

                                     $json_prod_data_trg = $dbResult_prod_conf_detl_trg[0]['detail'];

                                    // Loop through configurator data and parse for echo
                     $someObject_trg = "";       
                     $someObject_trg = json_decode($json_prod_data_trg);
                    

                    foreach($someObject_trg as $key_trg => $value_trg) {
                      $prod_data_echo = $prod_data_echo."\n".$value_trg->name . ":";
                     $someObject_trg_step1 = $value_trg->options;
                     $trg_count = 0;
                      foreach($someObject_trg_step1 as $key_trg_s1 => $value_trg_s1) {
                    	if ($value_trg_s1->selected == 1) {
                    	  if ($trg_count == 0) {
                    	  $prod_data_echo = $prod_data_echo." ".$value_trg_s1->name;
                    	  } else {
                    	  $prod_data_echo = $prod_data_echo.",".$value_trg_s1->name;
                    	  }
                      $trg_count ++;
                      }
                       
                    }
                     
                       $prod_data_echo = $prod_data_echo ."";
                     
                     
         
                    }
            
              }
              
              
            }
            // end get configurator product details
            
          // Si le module an_productfields est install
          
            if (Module::isInstalled(Tools::strtolower('an_productfields'))) {

            $prod_data_echo = "";    
           	       
            $prod_data_echo = substr($value['cart_name'], strlen($value['name']));
  
           
            $prod_data_echo = preg_replace('/-[\s\S]+?:/', '', $prod_data_echo);
            $prod_data_echo = str_replace(";",",",$prod_data_echo);
            $prod_data_echo = str_replace("\xc2\xa0", "", $prod_data_echo);  
            $prod_data_echo = str_replace("€", "e", $prod_data_echo); 
 
            $prod_data_echo = str_replace("   ", "", $prod_data_echo);
      
                   
                      
            if ($prod_data_echo != "") {$prod_data_echo = "\n".$prod_data_echo;}
            
            echo $prod_data_echo;
            }
            // end get an_productfields product details
            

  }    
                 
}                             
               // $space_left = $lineWidth - mb_strlen($product_qty) - mb_strlen($product_price);
               // if ($space_left > mb_strlen($product_name)) {
               //     $product_name .= str_repeat(" ", $space_left - mb_strlen($product_name));
               // } else {
               //     $product_name = mb_substr($product_name, 0, $space_left);
              //  }
                
                
                
                // removed for configurator detailed prod mode
               // $msgCommande .= $product_qty.$product_name.$product_price."\n";
               // removed for configurator detailed prod mode
               
  
              
        
        

            
            
  //       echo $prod_data_echo;
         
       print_r($order_infos);
         

         
              //   print_r($dbResult_prod_anproductfields_detl_trg);
 
              //   print_r($order_infos['product_list']);
              
         echo "<br /><br />php loaded.<br />";
?>